package cn.ibizlab.assetmanagement.core.apply.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[维护申请]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMAPPLY",resultMap = "EAMApplyResultMap")
public class EAMApply extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 维护申请标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamapplyid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamapplyid")
    @JsonProperty("eamapplyid")
    private String eamapplyid;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 维护申请名称
     */
    @TableField(value = "eamapplyname")
    @JSONField(name = "eamapplyname")
    @JsonProperty("eamapplyname")
    private String eamapplyname;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 维护申请类型标识
     */
    @TableField(value = "eamapplytypeid")
    @JSONField(name = "eamapplytypeid")
    @JsonProperty("eamapplytypeid")
    private String eamapplytypeid;
    /**
     * 功能位置标识
     */
    @TableField(value = "eamlocationid")
    @JSONField(name = "eamlocationid")
    @JsonProperty("eamlocationid")
    private String eamlocationid;
    /**
     * 资产标识
     */
    @TableField(value = "assetid")
    @JSONField(name = "assetid")
    @JsonProperty("assetid")
    private String assetid;
    /**
     * 描述
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * 希望开始时间
     */
    @TableField(value = "begintime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "begintime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("begintime")
    private Timestamp begintime;
    /**
     * 希望结束时间
     */
    @TableField(value = "endtime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "endtime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("endtime")
    private Timestamp endtime;
    /**
     * 资产
     */
    @TableField(exist = false)
    @JSONField(name = "assetname")
    @JsonProperty("assetname")
    private String assetname;
    /**
     * 功能位置
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationname")
    @JsonProperty("eamlocationname")
    private String eamlocationname;
    /**
     * 维护申请类型
     */
    @TableField(exist = false)
    @JSONField(name = "eamapplytypename")
    @JsonProperty("eamapplytypename")
    private String eamapplytypename;
    /**
     * 维护申请编号
     */
    @TableField(value = "applynumber")
    @JSONField(name = "applynumber")
    @JsonProperty("applynumber")
    private String applynumber;
    /**
     * 服务等级标识
     */
    @TableField(value = "eamservicelevelid")
    @JSONField(name = "eamservicelevelid")
    @JsonProperty("eamservicelevelid")
    private String eamservicelevelid;
    /**
     * 服务等级
     */
    @TableField(exist = false)
    @JSONField(name = "eamservicelevelname")
    @JsonProperty("eamservicelevelname")
    private String eamservicelevelname;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyType eamapplytype;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAsset asset;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocation eamlocation;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.workorder.domain.EAMServiceLevel eamservicelevel;



    /**
     * 设置 [维护申请名称]
     */
    public void setEamapplyname(String eamapplyname){
        this.eamapplyname = eamapplyname ;
        this.modify("eamapplyname",eamapplyname);
    }

    /**
     * 设置 [维护申请类型标识]
     */
    public void setEamapplytypeid(String eamapplytypeid){
        this.eamapplytypeid = eamapplytypeid ;
        this.modify("eamapplytypeid",eamapplytypeid);
    }

    /**
     * 设置 [功能位置标识]
     */
    public void setEamlocationid(String eamlocationid){
        this.eamlocationid = eamlocationid ;
        this.modify("eamlocationid",eamlocationid);
    }

    /**
     * 设置 [资产标识]
     */
    public void setAssetid(String assetid){
        this.assetid = assetid ;
        this.modify("assetid",assetid);
    }

    /**
     * 设置 [描述]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }

    /**
     * 设置 [希望开始时间]
     */
    public void setBegintime(Timestamp begintime){
        this.begintime = begintime ;
        this.modify("begintime",begintime);
    }

    /**
     * 格式化日期 [希望开始时间]
     */
    public String formatBegintime(){
        if (this.begintime == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(begintime);
    }
    /**
     * 设置 [希望结束时间]
     */
    public void setEndtime(Timestamp endtime){
        this.endtime = endtime ;
        this.modify("endtime",endtime);
    }

    /**
     * 格式化日期 [希望结束时间]
     */
    public String formatEndtime(){
        if (this.endtime == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(endtime);
    }
    /**
     * 设置 [维护申请编号]
     */
    public void setApplynumber(String applynumber){
        this.applynumber = applynumber ;
        this.modify("applynumber",applynumber);
    }

    /**
     * 设置 [服务等级标识]
     */
    public void setEamservicelevelid(String eamservicelevelid){
        this.eamservicelevelid = eamservicelevelid ;
        this.modify("eamservicelevelid",eamservicelevelid);
    }


}


