package cn.ibizlab.assetmanagement.core.apply.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[维护申请状态模型明细]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMAPPLYSTATEMODELLINE",resultMap = "EAMApplyStateModelLineResultMap")
public class EAMApplyStateModelLine extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 维护申请状态模型明细名称
     */
    @TableField(value = "eamapplystatemodellinename")
    @JSONField(name = "eamapplystatemodellinename")
    @JsonProperty("eamapplystatemodellinename")
    private String eamapplystatemodellinename;
    /**
     * 维护申请状态模型明细标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamapplystatemodellineid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamapplystatemodellineid")
    @JsonProperty("eamapplystatemodellineid")
    private String eamapplystatemodellineid;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 维护申请状态标识
     */
    @TableField(value = "eamapplystateid")
    @JSONField(name = "eamapplystateid")
    @JsonProperty("eamapplystateid")
    private String eamapplystateid;
    /**
     * 维护申请状态模型标识
     */
    @TableField(value = "eamapplystatemodelid")
    @JSONField(name = "eamapplystatemodelid")
    @JsonProperty("eamapplystatemodelid")
    private String eamapplystatemodelid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyStateModel eamapplystatemodel;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyState eamapplystate;



    /**
     * 设置 [维护申请状态模型明细名称]
     */
    public void setEamapplystatemodellinename(String eamapplystatemodellinename){
        this.eamapplystatemodellinename = eamapplystatemodellinename ;
        this.modify("eamapplystatemodellinename",eamapplystatemodellinename);
    }

    /**
     * 设置 [维护申请状态标识]
     */
    public void setEamapplystateid(String eamapplystateid){
        this.eamapplystateid = eamapplystateid ;
        this.modify("eamapplystateid",eamapplystateid);
    }

    /**
     * 设置 [维护申请状态模型标识]
     */
    public void setEamapplystatemodelid(String eamapplystatemodelid){
        this.eamapplystatemodelid = eamapplystatemodelid ;
        this.modify("eamapplystatemodelid",eamapplystatemodelid);
    }


}


