package cn.ibizlab.assetmanagement.core.apply.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyStateModel;
/**
 * 关系型数据实体[EAMApplyStateModel] 查询条件对象
 */
@Slf4j
@Data
public class EAMApplyStateModelSearchContext extends QueryWrapperContext<EAMApplyStateModel> {

	private String n_eamapplystatemodelname_like;//[维护申请状态模型名称]
	public void setN_eamapplystatemodelname_like(String n_eamapplystatemodelname_like) {
        this.n_eamapplystatemodelname_like = n_eamapplystatemodelname_like;
        if(!ObjectUtils.isEmpty(this.n_eamapplystatemodelname_like)){
            this.getSearchCond().like("eamapplystatemodelname", n_eamapplystatemodelname_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamapplystatemodelname", query)   
            );
		 }
	}
}



