package cn.ibizlab.assetmanagement.core.apply.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyState;
/**
 * 关系型数据实体[EAMApplyState] 查询条件对象
 */
@Slf4j
@Data
public class EAMApplyStateSearchContext extends QueryWrapperContext<EAMApplyState> {

	private String n_eamapplystatename_like;//[维护申请状态名称]
	public void setN_eamapplystatename_like(String n_eamapplystatename_like) {
        this.n_eamapplystatename_like = n_eamapplystatename_like;
        if(!ObjectUtils.isEmpty(this.n_eamapplystatename_like)){
            this.getSearchCond().like("eamapplystatename", n_eamapplystatename_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamapplystatename", query)   
            );
		 }
	}
}



