package cn.ibizlab.assetmanagement.core.apply.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.assetmanagement.core.apply.domain.EAMApply;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplySearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EAMApplyMapper extends BaseMapper<EAMApply>{

    Page<EAMApply> searchDefault(IPage page, @Param("srf") EAMApplySearchContext context, @Param("ew") Wrapper<EAMApply> wrapper) ;
    @Override
    EAMApply selectById(Serializable id);
    @Override
    int insert(EAMApply entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EAMApply entity);
    @Override
    int update(@Param(Constants.ENTITY) EAMApply entity, @Param("ew") Wrapper<EAMApply> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EAMApply> selectByEamapplytypeid(@Param("eamapplytypeid") Serializable eamapplytypeid) ;

    List<EAMApply> selectByAssetid(@Param("assetid") Serializable assetid) ;

    List<EAMApply> selectByEamlocationid(@Param("eamlocationid") Serializable eamlocationid) ;

    List<EAMApply> selectByEamservicelevelid(@Param("eamservicelevelid") Serializable eamservicelevelid) ;

}
