package cn.ibizlab.assetmanagement.core.asset.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[资产备件包]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMASSETPARTSGROUP",resultMap = "EAMAssetPartsGroupResultMap")
public class EAMAssetPartsGroup extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 资产类型标识
     */
    @TableField(value = "eamassettypeid")
    @JSONField(name = "eamassettypeid")
    @JsonProperty("eamassettypeid")
    private String eamassettypeid;
    /**
     * 备件包标识
     */
    @TableField(value = "eamsparepartsgroupid")
    @JSONField(name = "eamsparepartsgroupid")
    @JsonProperty("eamsparepartsgroupid")
    private String eamsparepartsgroupid;
    /**
     * 资产备件包标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamassetpartsgroupid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamassetpartsgroupid")
    @JsonProperty("eamassetpartsgroupid")
    private String eamassetpartsgroupid;
    /**
     * 资产备件包名称
     */
    @TableField(value = "eamassetpartsgroupname")
    @JSONField(name = "eamassetpartsgroupname")
    @JsonProperty("eamassetpartsgroupname")
    private String eamassetpartsgroupname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 备件包
     */
    @TableField(exist = false)
    @JSONField(name = "eamsparepartsgroupname")
    @JsonProperty("eamsparepartsgroupname")
    private String eamsparepartsgroupname;
    /**
     * 资产类型
     */
    @TableField(exist = false)
    @JSONField(name = "eamassettypename")
    @JsonProperty("eamassettypename")
    private String eamassettypename;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetType eamassettype;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMSparePartsGroup eamsparepartsgroup;



    /**
     * 设置 [资产类型标识]
     */
    public void setEamassettypeid(String eamassettypeid){
        this.eamassettypeid = eamassettypeid ;
        this.modify("eamassettypeid",eamassettypeid);
    }

    /**
     * 设置 [备件包标识]
     */
    public void setEamsparepartsgroupid(String eamsparepartsgroupid){
        this.eamsparepartsgroupid = eamsparepartsgroupid ;
        this.modify("eamsparepartsgroupid",eamsparepartsgroupid);
    }

    /**
     * 设置 [资产备件包名称]
     */
    public void setEamassetpartsgroupname(String eamassetpartsgroupname){
        this.eamassetpartsgroupname = eamassetpartsgroupname ;
        this.modify("eamassetpartsgroupname",eamassetpartsgroupname);
    }


}


