package cn.ibizlab.assetmanagement.core.asset.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[资产类型]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMASSETTYPE",resultMap = "EAMAssetTypeResultMap")
public class EAMAssetType extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 资产类型名称
     */
    @TableField(value = "eamassettypename")
    @JSONField(name = "eamassettypename")
    @JsonProperty("eamassettypename")
    private String eamassettypename;
    /**
     * 资产类型标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamassettypeid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamassettypeid")
    @JsonProperty("eamassettypeid")
    private String eamassettypeid;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 资产状态模型标识
     */
    @TableField(value = "eamassetstatemodelid")
    @JSONField(name = "eamassetstatemodelid")
    @JsonProperty("eamassetstatemodelid")
    private String eamassetstatemodelid;
    /**
     * 资产状态模型
     */
    @TableField(exist = false)
    @JSONField(name = "eamassetstatemodelname")
    @JsonProperty("eamassetstatemodelname")
    private String eamassetstatemodelname;
    /**
     * 资产类型编号
     */
    @TableField(value = "assettypenumber")
    @JSONField(name = "assettypenumber")
    @JsonProperty("assettypenumber")
    private String assettypenumber;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetStateModel eamassetstatemodel;



    /**
     * 设置 [资产类型名称]
     */
    public void setEamassettypename(String eamassettypename){
        this.eamassettypename = eamassettypename ;
        this.modify("eamassettypename",eamassettypename);
    }

    /**
     * 设置 [资产状态模型标识]
     */
    public void setEamassetstatemodelid(String eamassetstatemodelid){
        this.eamassetstatemodelid = eamassetstatemodelid ;
        this.modify("eamassetstatemodelid",eamassetstatemodelid);
    }

    /**
     * 设置 [资产类型编号]
     */
    public void setAssettypenumber(String assettypenumber){
        this.assettypenumber = assettypenumber ;
        this.modify("assettypenumber",assettypenumber);
    }


}


