package cn.ibizlab.assetmanagement.core.asset.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[备件包物料]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMSPAREPARTSPRO",resultMap = "EAMSparePartsPROResultMap")
public class EAMSparePartsPRO extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 备件包标识
     */
    @TableField(value = "eamsparepartsgroupid")
    @JSONField(name = "eamsparepartsgroupid")
    @JsonProperty("eamsparepartsgroupid")
    private String eamsparepartsgroupid;
    /**
     * 产品标识
     */
    @TableField(value = "productid")
    @JSONField(name = "productid")
    @JsonProperty("productid")
    private String productid;
    /**
     * 备件包物料标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamsparepartsproid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamsparepartsproid")
    @JsonProperty("eamsparepartsproid")
    private String eamsparepartsproid;
    /**
     * 备件包物料名称
     */
    @TableField(value = "eamsparepartsproname")
    @JSONField(name = "eamsparepartsproname")
    @JsonProperty("eamsparepartsproname")
    private String eamsparepartsproname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 备件包
     */
    @TableField(exist = false)
    @JSONField(name = "eamsparepartsgroupname")
    @JsonProperty("eamsparepartsgroupname")
    private String eamsparepartsgroupname;
    /**
     * 产品
     */
    @TableField(exist = false)
    @JSONField(name = "productname")
    @JsonProperty("productname")
    private String productname;
    /**
     * 产品编号
     */
    @TableField(exist = false)
    @JSONField(name = "productnumber")
    @JsonProperty("productnumber")
    private String productnumber;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMPRODUCT product;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMSparePartsGroup eamsparepartsgroup;



    /**
     * 设置 [备件包标识]
     */
    public void setEamsparepartsgroupid(String eamsparepartsgroupid){
        this.eamsparepartsgroupid = eamsparepartsgroupid ;
        this.modify("eamsparepartsgroupid",eamsparepartsgroupid);
    }

    /**
     * 设置 [产品标识]
     */
    public void setProductid(String productid){
        this.productid = productid ;
        this.modify("productid",productid);
    }

    /**
     * 设置 [备件包物料名称]
     */
    public void setEamsparepartsproname(String eamsparepartsproname){
        this.eamsparepartsproname = eamsparepartsproname ;
        this.modify("eamsparepartsproname",eamsparepartsproname);
    }


}


