package cn.ibizlab.assetmanagement.core.asset.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetStateModel;
/**
 * 关系型数据实体[EAMAssetStateModel] 查询条件对象
 */
@Slf4j
@Data
public class EAMAssetStateModelSearchContext extends QueryWrapperContext<EAMAssetStateModel> {

	private String n_eamassetstatemodelname_like;//[资产状态模型名称]
	public void setN_eamassetstatemodelname_like(String n_eamassetstatemodelname_like) {
        this.n_eamassetstatemodelname_like = n_eamassetstatemodelname_like;
        if(!ObjectUtils.isEmpty(this.n_eamassetstatemodelname_like)){
            this.getSearchCond().like("eamassetstatemodelname", n_eamassetstatemodelname_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamassetstatemodelname", query)   
            );
		 }
	}
}



