package cn.ibizlab.assetmanagement.core.asset.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.assetmanagement.core.asset.domain.EAMAsset;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EAMAssetMapper extends BaseMapper<EAMAsset>{

    Page<EAMAsset> searchDefault(IPage page, @Param("srf") EAMAssetSearchContext context, @Param("ew") Wrapper<EAMAsset> wrapper) ;
    @Override
    EAMAsset selectById(Serializable id);
    @Override
    int insert(EAMAsset entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EAMAsset entity);
    @Override
    int update(@Param(Constants.ENTITY) EAMAsset entity, @Param("ew") Wrapper<EAMAsset> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EAMAsset> selectByEamassetstateid(@Param("eamassetstateid") Serializable eamassetstateid) ;

    List<EAMAsset> selectByEamassettypeid(@Param("eamassettypeid") Serializable eamassettypeid) ;

    List<EAMAsset> selectByPassetid(@Param("assetid") Serializable assetid) ;

    List<EAMAsset> selectByEamlocationid(@Param("eamlocationid") Serializable eamlocationid) ;

}
