package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetType;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetTypeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAssetType] 服务对象接口
 */
public interface IEAMAssetTypeService extends IService<EAMAssetType>{

    boolean create(EAMAssetType et) ;
    void createBatch(List<EAMAssetType> list) ;
    boolean update(EAMAssetType et) ;
    void updateBatch(List<EAMAssetType> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAssetType get(String key) ;
    EAMAssetType getDraft(EAMAssetType et) ;
    boolean checkKey(EAMAssetType et) ;
    boolean save(EAMAssetType et) ;
    void saveBatch(List<EAMAssetType> list) ;
    Page<EAMAssetType> searchDefault(EAMAssetTypeSearchContext context) ;
    List<EAMAssetType> selectByEamassetstatemodelid(String eamassetstatemodelid) ;
    void removeByEamassetstatemodelid(String eamassetstatemodelid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAssetType> getEamassettypeByIds(List<String> ids) ;
    List<EAMAssetType> getEamassettypeByEntities(List<EAMAssetType> entities) ;
}


