package cn.ibizlab.assetmanagement.core.location.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[功能位置]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMLOCATION",resultMap = "EAMLocationResultMap")
public class EAMLocation extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 功能位置标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamlocationid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamlocationid")
    @JsonProperty("eamlocationid")
    private String eamlocationid;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 功能位置名称
     */
    @TableField(value = "eamlocationname")
    @JSONField(name = "eamlocationname")
    @JsonProperty("eamlocationname")
    private String eamlocationname;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 功能位置类型标识
     */
    @TableField(value = "eamlocationtypeid")
    @JSONField(name = "eamlocationtypeid")
    @JsonProperty("eamlocationtypeid")
    private String eamlocationtypeid;
    /**
     * 上级功能位置标识
     */
    @TableField(value = "peamlocationid")
    @JSONField(name = "peamlocationid")
    @JsonProperty("peamlocationid")
    private String peamlocationid;
    /**
     * 功能位置状态标识
     */
    @TableField(value = "eamlocationstateid")
    @JSONField(name = "eamlocationstateid")
    @JsonProperty("eamlocationstateid")
    private String eamlocationstateid;
    /**
     * 上级位置
     */
    @TableField(exist = false)
    @JSONField(name = "peamlocationname")
    @JsonProperty("peamlocationname")
    private String peamlocationname;
    /**
     * 功能位置类型
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationtypename")
    @JsonProperty("eamlocationtypename")
    private String eamlocationtypename;
    /**
     * 功能位置状态
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationstatename")
    @JsonProperty("eamlocationstatename")
    private String eamlocationstatename;
    /**
     * 功能位置编号
     */
    @TableField(value = "locationnumber")
    @JSONField(name = "locationnumber")
    @JsonProperty("locationnumber")
    private String locationnumber;
    /**
     * 描述
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocationState eamlocationstate;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocationType eamlocationtype;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocation peamlocation;



    /**
     * 设置 [功能位置名称]
     */
    public void setEamlocationname(String eamlocationname){
        this.eamlocationname = eamlocationname ;
        this.modify("eamlocationname",eamlocationname);
    }

    /**
     * 设置 [功能位置类型标识]
     */
    public void setEamlocationtypeid(String eamlocationtypeid){
        this.eamlocationtypeid = eamlocationtypeid ;
        this.modify("eamlocationtypeid",eamlocationtypeid);
    }

    /**
     * 设置 [上级功能位置标识]
     */
    public void setPeamlocationid(String peamlocationid){
        this.peamlocationid = peamlocationid ;
        this.modify("peamlocationid",peamlocationid);
    }

    /**
     * 设置 [功能位置状态标识]
     */
    public void setEamlocationstateid(String eamlocationstateid){
        this.eamlocationstateid = eamlocationstateid ;
        this.modify("eamlocationstateid",eamlocationstateid);
    }

    /**
     * 设置 [功能位置编号]
     */
    public void setLocationnumber(String locationnumber){
        this.locationnumber = locationnumber ;
        this.modify("locationnumber",locationnumber);
    }

    /**
     * 设置 [描述]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }


}


