package cn.ibizlab.assetmanagement.core.location.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[功能位置状态]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMLOCATIONSTATE",resultMap = "EAMLocationStateResultMap")
public class EAMLocationState extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 功能位置状态标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamlocationstateid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamlocationstateid")
    @JsonProperty("eamlocationstateid")
    private String eamlocationstateid;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 功能位置状态名称
     */
    @TableField(value = "eamlocationstatename")
    @JSONField(name = "eamlocationstatename")
    @JsonProperty("eamlocationstatename")
    private String eamlocationstatename;
    /**
     * 是否有效
     */
    @TableField(value = "available")
    @JSONField(name = "available")
    @JsonProperty("available")
    private Integer available;
    /**
     * 是否创建资产
     */
    @TableField(value = "setup")
    @JSONField(name = "setup")
    @JsonProperty("setup")
    private Integer setup;



    /**
     * 设置 [功能位置状态名称]
     */
    public void setEamlocationstatename(String eamlocationstatename){
        this.eamlocationstatename = eamlocationstatename ;
        this.modify("eamlocationstatename",eamlocationstatename);
    }

    /**
     * 设置 [是否有效]
     */
    public void setAvailable(Integer available){
        this.available = available ;
        this.modify("available",available);
    }

    /**
     * 设置 [是否创建资产]
     */
    public void setSetup(Integer setup){
        this.setup = setup ;
        this.modify("setup",setup);
    }


}


