package cn.ibizlab.assetmanagement.core.location.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[功能位置类型]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMLOCATIONTYPE",resultMap = "EAMLocationTypeResultMap")
public class EAMLocationType extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 功能位置类型名称
     */
    @TableField(value = "eamlocationtypename")
    @JSONField(name = "eamlocationtypename")
    @JsonProperty("eamlocationtypename")
    private String eamlocationtypename;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 功能位置类型标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamlocationtypeid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamlocationtypeid")
    @JsonProperty("eamlocationtypeid")
    private String eamlocationtypeid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 功能位置状态模型标识
     */
    @TableField(value = "eamlocationstatemodelid")
    @JSONField(name = "eamlocationstatemodelid")
    @JsonProperty("eamlocationstatemodelid")
    private String eamlocationstatemodelid;
    /**
     * 功能位置状态模型
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationstatemodelname")
    @JsonProperty("eamlocationstatemodelname")
    private String eamlocationstatemodelname;
    /**
     * 描述
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocationStateModel eamlocationstatemodel;



    /**
     * 设置 [功能位置类型名称]
     */
    public void setEamlocationtypename(String eamlocationtypename){
        this.eamlocationtypename = eamlocationtypename ;
        this.modify("eamlocationtypename",eamlocationtypename);
    }

    /**
     * 设置 [功能位置状态模型标识]
     */
    public void setEamlocationstatemodelid(String eamlocationstatemodelid){
        this.eamlocationstatemodelid = eamlocationstatemodelid ;
        this.modify("eamlocationstatemodelid",eamlocationstatemodelid);
    }

    /**
     * 设置 [描述]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }


}


