package cn.ibizlab.assetmanagement.core.location.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.location.domain.EAMLocationStateModelLine;
/**
 * 关系型数据实体[EAMLocationStateModelLine] 查询条件对象
 */
@Slf4j
@Data
public class EAMLocationStateModelLineSearchContext extends QueryWrapperContext<EAMLocationStateModelLine> {

	private String n_eamlocationstatemodellinename_like;//[功能位置状态模型明细名称]
	public void setN_eamlocationstatemodellinename_like(String n_eamlocationstatemodellinename_like) {
        this.n_eamlocationstatemodellinename_like = n_eamlocationstatemodellinename_like;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatemodellinename_like)){
            this.getSearchCond().like("eamlocationstatemodellinename", n_eamlocationstatemodellinename_like);
        }
    }
	private String n_eamlocationstatemodelid_eq;//[功能位置状态模型标识]
	public void setN_eamlocationstatemodelid_eq(String n_eamlocationstatemodelid_eq) {
        this.n_eamlocationstatemodelid_eq = n_eamlocationstatemodelid_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatemodelid_eq)){
            this.getSearchCond().eq("eamlocationstatemodelid", n_eamlocationstatemodelid_eq);
        }
    }
	private String n_eamlocationstateid_eq;//[功能位置状态标识]
	public void setN_eamlocationstateid_eq(String n_eamlocationstateid_eq) {
        this.n_eamlocationstateid_eq = n_eamlocationstateid_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstateid_eq)){
            this.getSearchCond().eq("eamlocationstateid", n_eamlocationstateid_eq);
        }
    }
	private String n_eamlocationstatename_eq;//[功能位置状态]
	public void setN_eamlocationstatename_eq(String n_eamlocationstatename_eq) {
        this.n_eamlocationstatename_eq = n_eamlocationstatename_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatename_eq)){
            this.getSearchCond().eq("eamlocationstatename", n_eamlocationstatename_eq);
        }
    }
	private String n_eamlocationstatename_like;//[功能位置状态]
	public void setN_eamlocationstatename_like(String n_eamlocationstatename_like) {
        this.n_eamlocationstatename_like = n_eamlocationstatename_like;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatename_like)){
            this.getSearchCond().like("eamlocationstatename", n_eamlocationstatename_like);
        }
    }
	private String n_eamlocationstatemodelname_eq;//[功能位置状态模型]
	public void setN_eamlocationstatemodelname_eq(String n_eamlocationstatemodelname_eq) {
        this.n_eamlocationstatemodelname_eq = n_eamlocationstatemodelname_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatemodelname_eq)){
            this.getSearchCond().eq("eamlocationstatemodelname", n_eamlocationstatemodelname_eq);
        }
    }
	private String n_eamlocationstatemodelname_like;//[功能位置状态模型]
	public void setN_eamlocationstatemodelname_like(String n_eamlocationstatemodelname_like) {
        this.n_eamlocationstatemodelname_like = n_eamlocationstatemodelname_like;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatemodelname_like)){
            this.getSearchCond().like("eamlocationstatemodelname", n_eamlocationstatemodelname_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamlocationstatemodellinename", query)   
            );
		 }
	}
}



