package cn.ibizlab.assetmanagement.core.location.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.location.domain.EAMLocationState;
/**
 * 关系型数据实体[EAMLocationState] 查询条件对象
 */
@Slf4j
@Data
public class EAMLocationStateSearchContext extends QueryWrapperContext<EAMLocationState> {

	private String n_eamlocationstatename_like;//[功能位置状态名称]
	public void setN_eamlocationstatename_like(String n_eamlocationstatename_like) {
        this.n_eamlocationstatename_like = n_eamlocationstatename_like;
        if(!ObjectUtils.isEmpty(this.n_eamlocationstatename_like)){
            this.getSearchCond().like("eamlocationstatename", n_eamlocationstatename_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamlocationstatename", query)   
            );
		 }
	}
}



