package cn.ibizlab.assetmanagement.core.plan.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[维护计划]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMPLAN",resultMap = "EAMPlanResultMap")
public class EAMPlan extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 维护计划名称
     */
    @TableField(value = "eamplanname")
    @JSONField(name = "eamplanname")
    @JsonProperty("eamplanname")
    private String eamplanname;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 维护计划标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamplanid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamplanid")
    @JsonProperty("eamplanid")
    private String eamplanid;
    /**
     * 功能位置标识
     */
    @TableField(value = "eamlocationid")
    @JSONField(name = "eamlocationid")
    @JsonProperty("eamlocationid")
    private String eamlocationid;
    /**
     * 资产标识
     */
    @TableField(value = "assetid")
    @JSONField(name = "assetid")
    @JsonProperty("assetid")
    private String assetid;
    /**
     * 资产
     */
    @TableField(exist = false)
    @JSONField(name = "assetname")
    @JsonProperty("assetname")
    private String assetname;
    /**
     * 功能位置
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationname")
    @JsonProperty("eamlocationname")
    private String eamlocationname;
    /**
     * 计划编号
     */
    @TableField(value = "plannumber")
    @JSONField(name = "plannumber")
    @JsonProperty("plannumber")
    private String plannumber;
    /**
     * 测点标识
     */
    @TableField(value = "eammonitorpointid")
    @JSONField(name = "eammonitorpointid")
    @JsonProperty("eammonitorpointid")
    private String eammonitorpointid;
    /**
     * 测点
     */
    @TableField(exist = false)
    @JSONField(name = "eammonitorpointname")
    @JsonProperty("eammonitorpointname")
    private String eammonitorpointname;
    /**
     * 描述
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * 制定日期
     */
    @TableField(value = "mdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "mdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("mdate")
    private Timestamp mdate;
    /**
     * 内容
     */
    @TableField(value = "content")
    @JSONField(name = "content")
    @JsonProperty("content")
    private String content;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAsset asset;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocation eamlocation;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.workorder.domain.EAMMonitorPoint eammonitorpoint;



    /**
     * 设置 [维护计划名称]
     */
    public void setEamplanname(String eamplanname){
        this.eamplanname = eamplanname ;
        this.modify("eamplanname",eamplanname);
    }

    /**
     * 设置 [功能位置标识]
     */
    public void setEamlocationid(String eamlocationid){
        this.eamlocationid = eamlocationid ;
        this.modify("eamlocationid",eamlocationid);
    }

    /**
     * 设置 [资产标识]
     */
    public void setAssetid(String assetid){
        this.assetid = assetid ;
        this.modify("assetid",assetid);
    }

    /**
     * 设置 [计划编号]
     */
    public void setPlannumber(String plannumber){
        this.plannumber = plannumber ;
        this.modify("plannumber",plannumber);
    }

    /**
     * 设置 [测点标识]
     */
    public void setEammonitorpointid(String eammonitorpointid){
        this.eammonitorpointid = eammonitorpointid ;
        this.modify("eammonitorpointid",eammonitorpointid);
    }

    /**
     * 设置 [描述]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }

    /**
     * 设置 [制定日期]
     */
    public void setMdate(Timestamp mdate){
        this.mdate = mdate ;
        this.modify("mdate",mdate);
    }

    /**
     * 格式化日期 [制定日期]
     */
    public String formatMdate(){
        if (this.mdate == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(mdate);
    }
    /**
     * 设置 [内容]
     */
    public void setContent(String content){
        this.content = content ;
        this.modify("content",content);
    }


}


