package cn.ibizlab.assetmanagement.core.plan.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[维护计划条件]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMPLANCDT",resultMap = "EAMPlanCDTResultMap")
public class EAMPlanCDT extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 维护计划条件标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamplancdtid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamplancdtid")
    @JsonProperty("eamplancdtid")
    private String eamplancdtid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 维护计划条件名称
     */
    @TableField(value = "eamplancdtname")
    @JSONField(name = "eamplancdtname")
    @JsonProperty("eamplancdtname")
    private String eamplancdtname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 维护计划标识
     */
    @TableField(value = "eamplanid")
    @JSONField(name = "eamplanid")
    @JsonProperty("eamplanid")
    private String eamplanid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.plan.domain.EAMPlan eamplan;



    /**
     * 设置 [维护计划条件名称]
     */
    public void setEamplancdtname(String eamplancdtname){
        this.eamplancdtname = eamplancdtname ;
        this.modify("eamplancdtname",eamplancdtname);
    }

    /**
     * 设置 [维护计划标识]
     */
    public void setEamplanid(String eamplanid){
        this.eamplanid = eamplanid ;
        this.modify("eamplanid",eamplanid);
    }


}


