package cn.ibizlab.assetmanagement.core.plan.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[计划步骤]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMPLANLINE",resultMap = "EAMPlanLineResultMap")
public class EAMPlanLine extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 计划步骤标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamplanlineid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamplanlineid")
    @JsonProperty("eamplanlineid")
    private String eamplanlineid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 计划步骤名称
     */
    @TableField(value = "eamplanlinename")
    @JSONField(name = "eamplanlinename")
    @JsonProperty("eamplanlinename")
    private String eamplanlinename;
    /**
     * 维护计划标识
     */
    @TableField(value = "eamplanid")
    @JSONField(name = "eamplanid")
    @JsonProperty("eamplanid")
    private String eamplanid;
    /**
     * 功能位置标识
     */
    @TableField(value = "eamlocationid")
    @JSONField(name = "eamlocationid")
    @JsonProperty("eamlocationid")
    private String eamlocationid;
    /**
     * 资产标识
     */
    @TableField(value = "assetid")
    @JSONField(name = "assetid")
    @JsonProperty("assetid")
    private String assetid;
    /**
     * 序号
     */
    @TableField(value = "sortnumber")
    @JSONField(name = "sortnumber")
    @JsonProperty("sortnumber")
    private Integer sortnumber;
    /**
     * 内容
     */
    @TableField(value = "content")
    @JSONField(name = "content")
    @JsonProperty("content")
    private String content;
    /**
     * 维护计划
     */
    @TableField(exist = false)
    @JSONField(name = "eamplanname")
    @JsonProperty("eamplanname")
    private String eamplanname;
    /**
     * 资产
     */
    @TableField(exist = false)
    @JSONField(name = "assetname")
    @JsonProperty("assetname")
    private String assetname;
    /**
     * 功能位置
     */
    @TableField(exist = false)
    @JSONField(name = "eamlocationname")
    @JsonProperty("eamlocationname")
    private String eamlocationname;
    /**
     * 测点标识
     */
    @TableField(value = "eammonitorpointid")
    @JSONField(name = "eammonitorpointid")
    @JsonProperty("eammonitorpointid")
    private String eammonitorpointid;
    /**
     * 测点
     */
    @TableField(exist = false)
    @JSONField(name = "eammonitorpointname")
    @JsonProperty("eammonitorpointname")
    private String eammonitorpointname;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAsset asset;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.location.domain.EAMLocation eamlocation;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.workorder.domain.EAMMonitorPoint eammonitorpoint;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.plan.domain.EAMPlan eamplan;



    /**
     * 设置 [计划步骤名称]
     */
    public void setEamplanlinename(String eamplanlinename){
        this.eamplanlinename = eamplanlinename ;
        this.modify("eamplanlinename",eamplanlinename);
    }

    /**
     * 设置 [维护计划标识]
     */
    public void setEamplanid(String eamplanid){
        this.eamplanid = eamplanid ;
        this.modify("eamplanid",eamplanid);
    }

    /**
     * 设置 [功能位置标识]
     */
    public void setEamlocationid(String eamlocationid){
        this.eamlocationid = eamlocationid ;
        this.modify("eamlocationid",eamlocationid);
    }

    /**
     * 设置 [资产标识]
     */
    public void setAssetid(String assetid){
        this.assetid = assetid ;
        this.modify("assetid",assetid);
    }

    /**
     * 设置 [序号]
     */
    public void setSortnumber(Integer sortnumber){
        this.sortnumber = sortnumber ;
        this.modify("sortnumber",sortnumber);
    }

    /**
     * 设置 [内容]
     */
    public void setContent(String content){
        this.content = content ;
        this.modify("content",content);
    }

    /**
     * 设置 [测点标识]
     */
    public void setEammonitorpointid(String eammonitorpointid){
        this.eammonitorpointid = eammonitorpointid ;
        this.modify("eammonitorpointid",eammonitorpointid);
    }


}


