package cn.ibizlab.assetmanagement.core.plan.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.plan.domain.EAMPlan;
/**
 * 关系型数据实体[EAMPlan] 查询条件对象
 */
@Slf4j
@Data
public class EAMPlanSearchContext extends QueryWrapperContext<EAMPlan> {

	private String n_eamplanname_like;//[维护计划名称]
	public void setN_eamplanname_like(String n_eamplanname_like) {
        this.n_eamplanname_like = n_eamplanname_like;
        if(!ObjectUtils.isEmpty(this.n_eamplanname_like)){
            this.getSearchCond().like("eamplanname", n_eamplanname_like);
        }
    }
	private String n_eamlocationid_eq;//[功能位置标识]
	public void setN_eamlocationid_eq(String n_eamlocationid_eq) {
        this.n_eamlocationid_eq = n_eamlocationid_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationid_eq)){
            this.getSearchCond().eq("eamlocationid", n_eamlocationid_eq);
        }
    }
	private String n_assetid_eq;//[资产标识]
	public void setN_assetid_eq(String n_assetid_eq) {
        this.n_assetid_eq = n_assetid_eq;
        if(!ObjectUtils.isEmpty(this.n_assetid_eq)){
            this.getSearchCond().eq("assetid", n_assetid_eq);
        }
    }
	private String n_assetname_eq;//[资产]
	public void setN_assetname_eq(String n_assetname_eq) {
        this.n_assetname_eq = n_assetname_eq;
        if(!ObjectUtils.isEmpty(this.n_assetname_eq)){
            this.getSearchCond().eq("assetname", n_assetname_eq);
        }
    }
	private String n_assetname_like;//[资产]
	public void setN_assetname_like(String n_assetname_like) {
        this.n_assetname_like = n_assetname_like;
        if(!ObjectUtils.isEmpty(this.n_assetname_like)){
            this.getSearchCond().like("assetname", n_assetname_like);
        }
    }
	private String n_eamlocationname_eq;//[功能位置]
	public void setN_eamlocationname_eq(String n_eamlocationname_eq) {
        this.n_eamlocationname_eq = n_eamlocationname_eq;
        if(!ObjectUtils.isEmpty(this.n_eamlocationname_eq)){
            this.getSearchCond().eq("eamlocationname", n_eamlocationname_eq);
        }
    }
	private String n_eamlocationname_like;//[功能位置]
	public void setN_eamlocationname_like(String n_eamlocationname_like) {
        this.n_eamlocationname_like = n_eamlocationname_like;
        if(!ObjectUtils.isEmpty(this.n_eamlocationname_like)){
            this.getSearchCond().like("eamlocationname", n_eamlocationname_like);
        }
    }
	private String n_eammonitorpointid_eq;//[测点标识]
	public void setN_eammonitorpointid_eq(String n_eammonitorpointid_eq) {
        this.n_eammonitorpointid_eq = n_eammonitorpointid_eq;
        if(!ObjectUtils.isEmpty(this.n_eammonitorpointid_eq)){
            this.getSearchCond().eq("eammonitorpointid", n_eammonitorpointid_eq);
        }
    }
	private String n_eammonitorpointname_eq;//[测点]
	public void setN_eammonitorpointname_eq(String n_eammonitorpointname_eq) {
        this.n_eammonitorpointname_eq = n_eammonitorpointname_eq;
        if(!ObjectUtils.isEmpty(this.n_eammonitorpointname_eq)){
            this.getSearchCond().eq("eammonitorpointname", n_eammonitorpointname_eq);
        }
    }
	private String n_eammonitorpointname_like;//[测点]
	public void setN_eammonitorpointname_like(String n_eammonitorpointname_like) {
        this.n_eammonitorpointname_like = n_eammonitorpointname_like;
        if(!ObjectUtils.isEmpty(this.n_eammonitorpointname_like)){
            this.getSearchCond().like("eammonitorpointname", n_eammonitorpointname_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamplanname", query)   
            );
		 }
	}
}



