package cn.ibizlab.assetmanagement.core.workorder.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[工单状态模型明细]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMWOSTATEMODELLINE",resultMap = "EAMWOStateModelLineResultMap")
public class EAMWOStateModelLine extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 工单状态模型明细标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamwostatemodellineid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamwostatemodellineid")
    @JsonProperty("eamwostatemodellineid")
    private String eamwostatemodellineid;
    /**
     * 工单状态模型明细名称
     */
    @TableField(value = "eamwostatemodellinename")
    @JSONField(name = "eamwostatemodellinename")
    @JsonProperty("eamwostatemodellinename")
    private String eamwostatemodellinename;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 工单状态模型标识
     */
    @TableField(value = "eamwostatemodelid")
    @JSONField(name = "eamwostatemodelid")
    @JsonProperty("eamwostatemodelid")
    private String eamwostatemodelid;
    /**
     * 工单状态标识
     */
    @TableField(value = "eamwostateid")
    @JSONField(name = "eamwostateid")
    @JsonProperty("eamwostateid")
    private String eamwostateid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOStateModel eamwostatemodel;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOState eamwostate;



    /**
     * 设置 [工单状态模型明细名称]
     */
    public void setEamwostatemodellinename(String eamwostatemodellinename){
        this.eamwostatemodellinename = eamwostatemodellinename ;
        this.modify("eamwostatemodellinename",eamwostatemodellinename);
    }

    /**
     * 设置 [工单状态模型标识]
     */
    public void setEamwostatemodelid(String eamwostatemodelid){
        this.eamwostatemodelid = eamwostatemodelid ;
        this.modify("eamwostatemodelid",eamwostatemodelid);
    }

    /**
     * 设置 [工单状态标识]
     */
    public void setEamwostateid(String eamwostateid){
        this.eamwostateid = eamwostateid ;
        this.modify("eamwostateid",eamwostateid);
    }


}


