package cn.ibizlab.assetmanagement.core.workorder.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[工单来源]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMWOORIGIN",resultMap = "WOOriginResultMap")
public class WOOrigin extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 工单来源标识
     */
    @DEField(name = "eamwooriginid" , isKeyField=true)
    @TableId(value= "eamwooriginid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "wooriginid")
    @JsonProperty("wooriginid")
    private String wooriginid;
    /**
     * 工单来源名称
     */
    @DEField(name = "eamwooriginname")
    @TableField(value = "eamwooriginname")
    @JSONField(name = "wooriginname")
    @JsonProperty("wooriginname")
    private String wooriginname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 工单来源类型
     */
    @DEField(name = "eamwoorigintype")
    @TableField(value = "eamwoorigintype")
    @JSONField(name = "woorigintype")
    @JsonProperty("woorigintype")
    private String woorigintype;



    /**
     * 设置 [工单来源名称]
     */
    public void setWooriginname(String wooriginname){
        this.wooriginname = wooriginname ;
        this.modify("eamwooriginname",wooriginname);
    }

    /**
     * 设置 [工单来源类型]
     */
    public void setWoorigintype(String woorigintype){
        this.woorigintype = woorigintype ;
        this.modify("eamwoorigintype",woorigintype);
    }


}


