package cn.ibizlab.assetmanagement.core.workorder.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.assetmanagement.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.assetmanagement.core.workorder.domain.EAMServiceLevel;
/**
 * 关系型数据实体[EAMServiceLevel] 查询条件对象
 */
@Slf4j
@Data
public class EAMServiceLevelSearchContext extends QueryWrapperContext<EAMServiceLevel> {

	private String n_eamservicelevelname_like;//[服务等级名称]
	public void setN_eamservicelevelname_like(String n_eamservicelevelname_like) {
        this.n_eamservicelevelname_like = n_eamservicelevelname_like;
        if(!ObjectUtils.isEmpty(this.n_eamservicelevelname_like)){
            this.getSearchCond().like("eamservicelevelname", n_eamservicelevelname_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("eamservicelevelname", query)   
            );
		 }
	}
}



