package cn.ibizlab.assetmanagement.core.workorder.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOStateModelLine;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWOStateModelLineSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EAMWOStateModelLineMapper extends BaseMapper<EAMWOStateModelLine>{

    Page<EAMWOStateModelLine> searchDefault(IPage page, @Param("srf") EAMWOStateModelLineSearchContext context, @Param("ew") Wrapper<EAMWOStateModelLine> wrapper) ;
    @Override
    EAMWOStateModelLine selectById(Serializable id);
    @Override
    int insert(EAMWOStateModelLine entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EAMWOStateModelLine entity);
    @Override
    int update(@Param(Constants.ENTITY) EAMWOStateModelLine entity, @Param("ew") Wrapper<EAMWOStateModelLine> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EAMWOStateModelLine> selectByEamwostatemodelid(@Param("eamwostatemodelid") Serializable eamwostatemodelid) ;

    List<EAMWOStateModelLine> selectByEamwostateid(@Param("eamwostateid") Serializable eamwostateid) ;

}
