package cn.ibizlab.assetmanagement.core.workorder.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWorkOrder;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWorkOrderSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EAMWorkOrderMapper extends BaseMapper<EAMWorkOrder>{

    Page<EAMWorkOrder> searchChildWO(IPage page, @Param("srf") EAMWorkOrderSearchContext context, @Param("ew") Wrapper<EAMWorkOrder> wrapper) ;
    Page<EAMWorkOrder> searchDefault(IPage page, @Param("srf") EAMWorkOrderSearchContext context, @Param("ew") Wrapper<EAMWorkOrder> wrapper) ;
    @Override
    EAMWorkOrder selectById(Serializable id);
    @Override
    int insert(EAMWorkOrder entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EAMWorkOrder entity);
    @Override
    int update(@Param(Constants.ENTITY) EAMWorkOrder entity, @Param("ew") Wrapper<EAMWorkOrder> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EAMWorkOrder> selectByAssetid(@Param("assetid") Serializable assetid) ;

    List<EAMWorkOrder> selectByEamlocationid(@Param("eamlocationid") Serializable eamlocationid) ;

    List<EAMWorkOrder> selectByEamservicelevelid(@Param("eamservicelevelid") Serializable eamservicelevelid) ;

    List<EAMWorkOrder> selectByWooriginid(@Param("wooriginid") Serializable wooriginid) ;

    List<EAMWorkOrder> selectByPworkorderid(@Param("workorderid") Serializable workorderid) ;

    List<EAMWorkOrder> selectByEamwotypeid(@Param("eamwotypeid") Serializable eamwotypeid) ;

}
