package cn.ibizlab.assetmanagement.core.workorder.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.workorder.domain.EAMMonitorPoint;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMMonitorPointSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMMonitorPoint] 服务对象接口
 */
public interface IEAMMonitorPointService extends IService<EAMMonitorPoint>{

    boolean create(EAMMonitorPoint et) ;
    void createBatch(List<EAMMonitorPoint> list) ;
    boolean update(EAMMonitorPoint et) ;
    void updateBatch(List<EAMMonitorPoint> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMMonitorPoint get(String key) ;
    EAMMonitorPoint getDraft(EAMMonitorPoint et) ;
    boolean checkKey(EAMMonitorPoint et) ;
    boolean save(EAMMonitorPoint et) ;
    void saveBatch(List<EAMMonitorPoint> list) ;
    Page<EAMMonitorPoint> searchDefault(EAMMonitorPointSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMMonitorPoint> getEammonitorpointByIds(List<String> ids) ;
    List<EAMMonitorPoint> getEammonitorpointByEntities(List<EAMMonitorPoint> entities) ;
}


